//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// December 13, 1999
//
// Launch netscape on a piece of SAS html documentation. Makes use of
// SAS_PATH.
//
#include "sashelp.h"

#include <errstr.h>
#include <param.h>
#include <Tracer.h>
#include <SasFileLocator.h>

#include <string>
#include <vector>

bool netscape(const string url, bool otherwindow = false){
  PROC
  string s = "";
  if(otherwindow)
    s = ", new-window";
  clog << "Trying to talk to a running Netscape ... ";
  if(system(string("netscape -remote \"openURL(" + url + s + ")\"").c_str())){
    clog << "failed." << endl;
    clog << "Trying to start netscape in the background ...";
    if(system(string("netscape " + url + "&").c_str())){
      clog << "failed again." << endl;
      ALTRETURNV(false)
    }
  }
  clog << endl;
  RETURN true;
}


void sashelp () {
  PROC
    // There are two types of html files:
    //   + <subdir of SAS_PATH>/doc/<something>.html
    //   + <subdir of SAS_PATH>/doc/<something>/index.html
  string s = stringParameter("doc");
  string toptarget = "doc/" + s + ".html";
  string tasktarget = "doc/" + s + "/" + "index.html";
  string topdoc = fileLocator.locate(toptarget, "", false);
  string taskdoc = fileLocator.locate(tasktarget, "", false);
  if(topdoc.size() > 0){
    netscape("file://" + topdoc);
    if(taskdoc.size() > 0){
      clog << "Found two matching documents. Opening both of them." << endl;
      netscape("file://" + taskdoc, true);
    }
  } else {
    if(taskdoc.size() > 0)
      netscape("file://" + taskdoc);
    else{
      string readme = fileLocator.locate("README.html");
      netscape("file://" + readme);
    }
  }
  ENDPROC
}
  
  
